=== debian/changelog ===
flint (3.1.3-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/builtin-overflow.patch
    - New patch; use integer overflow builtins on armhf (Closes: #1091291).

 -- Doug Torrance <dtorrance@debian.org>  Sun, 05 Jan 2025 08:31:12 -0500

flint (3.1.3-1) unstable; urgency=medium

  * Drop unneeded stanza from debian/copyright.
  * Bump standards-version to 4.7.0.
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 09 Jun 2024 15:52:16 +0200

flint (3.1.2-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 02 Apr 2024 16:19:18 -0400

flint (3.1.2-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control
    - Rename libflint18t64 -> libflint19 (Closes: #1067226).
    - Add Breaks/Replaces for libflint18t64, but only for version 3.1.0 or
      greater, where soversion 19 first appeared.
  * debian/libflint19.install
    - Rename from libflint18t64.install
  * debian/libflint18t64.lintian-overrides
    - Remove file; no longer necessary now that the package name matches
      the soname.
  * debian/libflint18t64.shlibs
    - Remove file; generated automatically by debhelper.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 26 Mar 2024 13:30:18 -0400

flint (3.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 15 Mar 2024 12:15:07 +0100

flint (3.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064626

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 08:46:24 +0000
