=== debian/changelog ===
flint (3.3.1-2) unstable; urgency=medium

  * debian/rules
    - Build with -fno-strict-aliasing to fix FTBFS when compiling with
      GCC 15 (Closes: #1114011).
  * debian/salsa-ci.yml
    - New file; disable reprotest for now.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 05 Sep 2025 07:29:07 -0400

flint (3.3.1-1) unstable; urgency=medium

  * Upload to unstable for libflint19 -> libflint21 transition.

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Drop unnecessary dh arguments: --parallel

  [ John Scott ]
  * Update the DEP-8 test for clarity and to use newly-introduced
    functionality.

  [ Doug Torrance ]
  * debian/control
    - Add myself to Uploaders
    - Bump Standards-Version to 4.7.2.
  * debian/copyright
    - Add my copyright info to debian/* stanza.
  * debian/patches/builtin-overflow.patch
    - Restore patch as a workaround for another "not enough registers"
      compilation error on armhf that was introduced in the new release.
  * debian/patches/verbose-builds.patch
    - New patch; allow verbose builds with V make variable.
  * debian/rules
    - Update MAKE_OVERRIDE variable whose value is passed to make; include
      new V variable for verbose builds and remove old now-unused variables.
  * debian/tests/control
    - Drop strict aliasing when compiling test program; not an issue after
      the update.
  * debian/tests/matrix-bernoulli.c
    - Add header for rational vectors
  * debian/watch
    - Update url.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 03 Sep 2025 09:56:05 -0400

flint (3.3.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - Fixes GCC 15 build issues (Closes: #1096641, #1107362).
  * Upload to experimental for soversion bump transition.
  * Rename libflint19 -> libflint21 for soversion bump.
  * debian/control
    - Drop Breaks/Replaces for libflint18t64; no longer necessary.
  * debian/copyright
    - Replace old postal FSF address with url.
  * debian/libflint-doc.*
    - Update name of pdf documentation file.
  * debian/patches/builtin-overflow.patch
    - Remove patch; issue fixed upstream.
  * debian/patches/local-mathjax.patch
    - Refresh for new release.
  * debian/tests/control
    - Compile test program with strict aliasing as workaround for upstream
      bug.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 27 Aug 2025 12:22:44 -0400
