=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: math
 Priority: optional
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
-Uploaders: Julien Puydt <jpuydt@debian.org>
-Homepage: http://www.flintlib.org/
+Uploaders: Julien Puydt <jpuydt@debian.org>,
+           Doug Torrance <dtorrance@debian.org>
+Homepage: https://www.flintlib.org/
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                latexmk,
                libgmp-dev,
@@ -13,14 +14,12 @@
                python3-sphinx,
                texlive-fonts-recommended,
                texlive-latex-extra
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/math-team/flint
 Vcs-Git: https://salsa.debian.org/math-team/flint.git
 
-Package: libflint19
-Replaces: libflint18t64 (>= 3.1.0)
-Breaks: libflint18t64 (>= 3.1.0)
+Package: libflint21
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -39,7 +38,7 @@
 Package: libflint-dev
 Section: libdevel
 Architecture: any
-Depends: libflint19 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
+Depends: libflint21 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
 Description: C library for number theory, development files
  The Fast Library for Integer Number Theory is a C library which supports
  polynomial arithmetic over the integers, fast integer arithmetic and factoring
