=== debian/rules ===
--- 
+++ 
@@ -8,16 +8,18 @@
 CONFIGURE_FLAGS = --=$(DEB_HOST_GNU_CPU)-$(DEB_HOST_ARCH_OS) CC=$(CC) CXX=$(CXX) AR=$(AR)
 endif
 
-MAKE_OVERRIDE = AT= QUIET_CXX= QUIET_CC= QUIET_AR= \
-		INCS='-I$(CURDIR) -I$(CURDIR)/build' ABI_FLAG='$(LDFLAGS)'
+export MAKE_OVERRIDE = V=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# https://github.com/flintlib/flint/issues/2340
+export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
 
 %:
 	dh $@ --with sphinxdoc
 
 override_dh_auto_build:
-	dh_auto_build --parallel -- $(MAKE_OVERRIDE)
+	dh_auto_build -- $(MAKE_OVERRIDE)
 	make -C doc html
 	make -C doc latexpdf
