=== debian/tests/control ===
Test-Command: gcc debian/tests/matrix-bernoulli.c -o "$AUTOPKGTEST_TMP"/matrix-bernoulli -lflint && "$AUTOPKGTEST_TMP"/matrix-bernoulli
Depends: gcc, libc-dev, libflint-dev
