=== debian/watch ===
version=4
https://github.com/flintlib/flint/tags .*/v?(\d[-\d.]*)\.tar\.gz
