=== debian/changelog ===
flint (3.4.0-1) unstable; urgency=medium

  * Source-only upload for transition to testing.
  * Upload to unstable.  (The previous version was supposed to go to
    experimental but ended up in unstable for some reason.)

 -- Doug Torrance <dtorrance@debian.org>  Wed, 26 Nov 2025 23:30:38 -0500

flint (3.4.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Rename libflint21 -> libflint22 for soversion bump
  * Upload to experimental ahead of soversion bump transition.
  * debian/control
    - Drop redundant Rules-Requires-Root field.
  * debian/patches/builtin-overflow.patch
    - Update bug url.
  * debian/patches/verbose-build.patch
    - Remove patch; applied upstream

 -- Doug Torrance <dtorrance@debian.org>  Wed, 26 Nov 2025 05:33:24 -0500
