=== debian/control ===
--- 
+++ 
@@ -15,11 +15,10 @@
                texlive-fonts-recommended,
                texlive-latex-extra
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/math-team/flint
 Vcs-Git: https://salsa.debian.org/math-team/flint.git
 
-Package: libflint21
+Package: libflint22
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -38,7 +37,7 @@
 Package: libflint-dev
 Section: libdevel
 Architecture: any
-Depends: libflint21 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
+Depends: libflint22 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
 Description: C library for number theory, development files
  The Fast Library for Integer Number Theory is a C library which supports
  polynomial arithmetic over the integers, fast integer arithmetic and factoring
